//Exercising arrays

#include <iostream>
#include <string.h>
#include "Time.h"

#define MAX 1000

using namespace std; 


int main(){

  int **a; //2-dimensional array will be dynamically allocated
  char *b;  //array/character string will be dynamically allocated
  Time **t; //array of pointers to Time objects will be dynamically allocated
            //The Time objects themselves will be dynamically allocated as well

  Time *t1[MAX]; //Same as above, but now the array of pointers to
                 //Time objects itself is automatically allocated

  int i, j, n, m;

  //Exercising strings (character arrays)

  char s[] = "Cristiana";

  cout << "Cristiana has a looong name of ";
  cout << strlen (s) << " characters" << endl;

  cout << "Even worse ! Her name ocupies 10 bytes because last character in a string should always be the NULL (\'\\0\') character" << endl; 
  //note how I output special characters like \ and ' - I need to put
  //a \ in front of them.

  char * ptr = new char[strlen(s) + 1]; //remember to allocate more 
                                        //space by one more character
  strcpy (ptr, s); //first string gets a copy of the second string

  cout << "This is also Cristiana's name: " << ptr << endl;

  if (strcmp (ptr, "Cristiana") == 0)
    cout << "Indeed it is also Cristiana's name: " << ptr << endl;

  cout << "Exercising various types of arrays with dynamic allocation" << endl;

  cout << "Input n (size of Time * arrays):";
  cin >> n; 
  cout << endl;

  b = new char [n];

  cout << "Exercising dynamically allocated array of Time * elements" << endl;

  //We allocate the array of pointers to Time objects

  t = new Time *[n]; //Line A

  //For each entry, we at some pint need to allocate space 
  //for the Time objects themselves

  for (i = 0; i < n; i++)
    {
      Time *noon = new Time; //Line XXX
      t[i] = noon; // t[i] in the array is set to point to the new Time object
    }              //However the object has not been initialized yet

  //Then we'll set some of the fields in the Time objects 
  //that the array entries are pointing to

  for (i = 0; i < n; i++)
    t[i]->settime(12, 0, 0); //set to noon time


  //Printing out all of the contents of the Time objects

  for (i = 0; i < n; i++)
    t[i]->Print(); //Printing out the hour, min, sec


  //I'm done, now need to free what I allocated dynamically

  for (i = 0; i < n; i++)
    delete t[i]; // freeing each Time object that has been allocated
                 //on Line XXX above

  delete [] t; //Freeing the array itself that has been dynamically allocated 
               //on
               //Line A above


  cout << "Exercising automatically allocated array of type Time * elements" << endl;
  //Same code as above but now with the automatically allocated array t1


  //We allocate the array of pointers to Time objects

  //For each entry, we at some pint need to allocate space 
  //for the Time objects themselves

  for (i = 0; i < n; i++)
    {
      Time *noon = new Time; //Line XXX
      t1[i] = noon; // t[i] in the array is set to point to the new Time object
    }              //However the object has not been initialized yet

  //Then we'll set some of the fields in the Time objects 
  //that the array entries are pointing to

  for (i = 0; i < n; i++)
    t1[i]->settime(12, 0, 0); //set to noon time

  //I'm done, now need to free what I allocated dynamically

  for (i = 0; i < n; i++)
    delete t1[i]; // freeing each Time object that has been allocated
                 //on Line XXX above

  //Printing out all of the contents of the Time objects

  for (i = 0; i < n; i++)
    t1[i]->Print(); //Printing out the hour, min, sec


  //No freeing of the array t1 itself since it has been automatically 
  //allocated 

  cout << "Exercising two-dimensional arrays with dynamic allocation" << endl;

  cout << "Input n (number of rows):";
  cin >> n; 

  cout << "Input m (number of columns):";
  cin >> m;
  cout << endl;

  a = new int *[n];
  for ( i = 0; i < n; i++)
    a[i] = new int [m];

  for ( i = 0; i < n; i++)
    for (j = 0; j < m; j++)
      cout << a[i][j] << ' ' ; //should be some random stuff
                               //array was not initialized
  cout << endl ;

  for ( i = 0; i < n; i++)
    delete [] a[i];
  delete [] a;
  
  return 0;
}

